package google

import (
	"fmt"
	"testing"

	"github.com/hashicorp/terraform-plugin-sdk/helper/resource"
)

func TestAccNotebooksEnvironment_create(t *testing.T) {
	t.Parallel()

	prefix := fmt.Sprintf("%d", randInt(t))
	name := fmt.Sprintf("tf-env-%s", prefix)

	vcrTest(t, resource.TestCase{
		Providers: testAccProviders,
		Steps: []resource.TestStep{
			{
				Config: testAccNotebooksEnvironment_create(name),
			},
			{
				ResourceName:      "google_notebooks_environment.test",
				ImportState:       true,
				ImportStateVerify: true,
			},
		},
	})
}

func testAccNotebooksEnvironment_create(name string) string {
	return fmt.Sprintf(`

resource "google_notebooks_environment" "test" {
  name = "%s"
  location = "us-west1-a"
  container_image {
    repository = "gcr.io/deeplearning-platform-release/base-cpu"
  }  
}
`, name)
}
